# std::ios_base Class Reference

The very top of the I/O class hierarchy. More...

`#include <ios_base.h>`

Inheritance diagram for std::ios_base:

[legend]
Collaboration diagram for std::ios_base:

[legend]
List of all members.

## Public Types

typedef IosFmtflags | fmtflags
| This is a bitmask type.
typedef IosIostate | iostate
| This is a bitmask type.
typedef IosOpenmode | openmode
| This is a bitmask type.
typedef IosSeekdir | seekdir
| This is an enumerated type.
typedef void(* | event_callback )(event, ios_base &, int)
| The type of an event callback function.
enum | event
| The set of events that may be passed to an event callback. More...

## Public Member Functions

void | register_callback (event_callback __fn, int index)
| Add the callback __fn with parameter index.
fmtflags | flags () const
| Access to format flags.
fmtflags | flags (fmtflags __fmtfl)
| Setting new format flags all at once.
fmtflags | setf (fmtflags __fmtfl)
| Setting new format flags.
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
| Setting new format flags.
void | unsetf (fmtflags __mask)
| Clearing format flags.
streamsize | precision () const
| Flags access.
streamsize | precision (streamsize __prec)
| Changing flags.
streamsize | width () const
| Flags access.
streamsize | width (streamsize __wide)
| Changing flags.
locale | imbue (const locale &__loc)
| Setting a new locale.
locale | getloc () const
| Locale access.
const locale & | M_getloc () const
| Locale access.
long & | iword (int __ix)
| Access to integer array.
void *& | pword (int __ix)
| Access to void pointer array.
virtual | ~ios_base ()

## Static Public Member Functions

bool | sync_with_stdio (bool sync=true)
| Interaction with the standard C I/O objects.
int | xalloc () throw ()
| Access to unique indices.

## Static Public Attributes

const fmtflags | boolalpha
| Insert/extract `bool` in alphabetic rather than numeric format.
const fmtflags | dec
| Converts integer input or generates integer output in decimal base.
const fmtflags | fixed
| Generate floating-point output in fixed-point notation.
const fmtflags | hex
| Converts integer input or generates integer output in hexadecimal base.
const fmtflags | internal
| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.
const fmtflags | left
| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).
const fmtflags | oct
| Converts integer input or generates integer output in octal base.
const fmtflags | right
| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).
const fmtflags | scientific
| Generates floating-point output in scientific notation.
const fmtflags | showbase
| Generates a prefix indicating the numeric base of generated integer output.
const fmtflags | showpoint
| Generates a decimal-point character unconditionally in generated floating-point output.
const fmtflags | showpos
| Generates a + sign in non-negative generated numeric output.
const fmtflags | skipws
| Skips leading white space before certain input operations.
const fmtflags | unitbuf
| Flushes output after each output operation.
const fmtflags | uppercase
| Replaces certain lowercase letters with their uppercase equivalents in generated output.
const fmtflags | adjustfield
| A mask of left|right|internal. Useful for the 2-arg form of `setf`.
const fmtflags | basefield
| A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.
const fmtflags | floatfield
| A mask of scientific|fixed. Useful for the 2-arg form of `setf`.
const iostate | badbit
| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).
const iostate | eofbit
| Indicates that an input operation reached the end of an input sequence.
const iostate | failbit
| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.
const iostate | goodbit
| Indicates all is well.
const openmode | app
| Seek to end before each write.
const openmode | ate
| Open and seek to end immediately after opening.
const openmode | binary
| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.
const openmode | in
| Open for input. Default for `ifstream` and fstream.
const openmode | out
| Open for output. Default for `ofstream` and fstream.
const openmode | trunc
| Open for input. Default for `ofstream`.
const seekdir | beg
| Request a seek relative to the beginning of the stream.
const seekdir | cur
| Request a seek relative to the current position within the sequence.
const seekdir | end
| Request a seek relative to the current end of the sequence.

## Detailed Description

The very top of the I/O class hierarchy.

This class defines everything that can be defined about I/O that does not depend on the type of characters being input or output. Most people will only see `ios_base` when they need to specify the full name of the various I/O flags (e.g., the openmodes).

Definition at line 158 of file ios_base.h.

## Member Typedef Documentation

typedef void(* std::ios_base::event_callback)(event, ios_base &, int)

The type of an event callback function.

Parameters:

  | event | One of the members of the event enum.
  | ios_base | Reference to the ios_base object.
  | int | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 394 of file ios_base.h.

Referenced by register_callback().

typedef IosFmtflags std::ios_base::fmtflags

This is a bitmask type.

`"IosFmtflags"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 210 of file ios_base.h.

Referenced by std::num_get< CharT, InIter >::do_get(), std::num_put< CharT, OutIter >::do_put(), std::basic_ostream< CharT, Traits >::operator<<(), std::basic_ostream< char >::operator<<(), and std::resetiosflags().

typedef IosIostate std::ios_base::iostate

This is a bitmask type.

`"IosIostate"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 285 of file ios_base.h.

Referenced by std::money_get< CharT, InIter >::get(), std::num_get< CharT, InIter >::get(), std::time_get< CharT, InIter >::get_time(), std::basic_ostream< CharT, Traits >::operator<<(), std::basic_istream< CharT, Traits >::operator>>(), std::operator>>(), and std::basic_istream< CharT, Traits >::sentry::sentry().

typedef IosOpenmode std::ios_base::openmode

This is a bitmask type.

`"IosOpenmode"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 316 of file ios_base.h.

Referenced by std::basic_ifstream< CharT, Traits >::basic_ifstream(), std::basic_ofstream< CharT, Traits >::basic_ofstream(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::pubseekoff(), std::basic_fstream< CharT, Traits >::rdbuf(), and __gnu_cxx::stdio_filebuf< CharT, Traits >::stdio_filebuf().

typedef IosSeekdir std::ios_base::seekdir

This is an enumerated type.

`"IosSeekdir"` is implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEKCUR` in the C standard library.
- end, equivalent to `SEEKEND` in the C standard library.

Definition at line 349 of file ios_base.h.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::pubseekoff(), std::basic_istream< CharT, Traits >::seekg(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), and std::basic_ostream< CharT, Traits >::seekp().

## Member Enumeration Documentation

enum std::ios_base::event

| The set of events that may be passed to an event callback. erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt(). Definition at line 377 of file ios_base.h.

## Constructor & Destructor Documentation

std::ios_base::~ios_base | ( |  | ) | `[virtual]`

| Invokes each callback with erase_event. Destroys local storage. Note that the ios_base object for the standard streams never gets destroyed. As a result, any callbacks registered with the standard streams will not get invoked with erase_event (unless copyfmt is used). Definition at line 125 of file ios.cc.

## Member Function Documentation

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) | `[inline]`

Setting new format flags all at once.

Parameters:

  | fmtfl | The new flags to set.

Returns:
  The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 517 of file ios_base.h.

fmtflags std::ios_base::flags | ( |  | ) | const`[inline]`

Access to format flags.

Returns:
  The format control flags for both input and output.

Definition at line 507 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::num_get< CharT, InIter >::do_get(), std::num_put< CharT, OutIter >::do_put(), std::basic_ostream< CharT, Traits >::operator<<(), std::basic_ostream< char >::operator<<(), std::operator<<(), and std::basic_istream< CharT, Traits >::sentry::sentry().

locale std::ios_base::getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 649 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::money_put< CharT, OutIter >::do_put(), std::operator>>(), and std::ws().

locale std::ios_base::imbue | ( | const locale & | __loc | ) |

Setting a new locale.

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Sets the new locale for this stream, and then invokes each callback with imbue_event.

Reimplemented in std::basic_ios< CharT, Traits >, and std::basic_ios< char, Traits >.

Definition at line 53 of file ios_locale.cc.

long& std::ios_base::iword | ( | int | __ix | ) | `[inline]`

Access to integer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 693 of file ios_base.h.

const locale& std::ios_base::M_getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 659 of file ios_base.h.

streamsize std::ios_base::precision | ( | streamsize | __prec | ) | `[inline]`

Changing flags.

Parameters:

  | prec | The new precision value.

Returns:
  The previous value of precision().

Definition at line 585 of file ios_base.h.

References std::streamsize.

streamsize std::ios_base::precision | ( |  | ) | const`[inline]`

Flags access.

Returns:
  The precision to generate on certain output operations.

Definition at line 577 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), and std::operator<<().

void*& std::ios_base::pword | ( | int | __ix | ) | `[inline]`

Access to void pointer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 714 of file ios_base.h.

References pword().

Referenced by pword().

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | index
| ) |

Add the callback __fn with parameter index.

Parameters:

  | __fn | The function to add.
  | index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

Definition at line 147 of file ios.cc.

References event_callback.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask
| ) | `[inline]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.
  | mask | The flags mask for fmtfl.

Returns:
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 550 of file ios_base.h.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) | `[inline]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.

Returns:
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 533 of file ios_base.h.

References setf().

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::right(), std::scientific(), setf(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

bool std::ios_base::sync_with_stdio | ( | bool | sync = `true` | ) | `[static]`

Interaction with the standard C I/O objects.

Parameters:

  | sync | Whether to synchronize or not.

Returns:
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

Definition at line 148 of file ios_init.cc.

References std::cerr, std::cin, std::clog, and std::cout.

void std::ios_base::unsetf | ( | fmtflags | __mask | ) | `[inline]`

Clearing format flags.

Parameters:

  | mask | The flags to unset.

This function clears mask in the format flags.

Definition at line 565 of file ios_base.h.

References unsetf().

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), std::nouppercase(), and unsetf().

streamsize std::ios_base::width | ( | streamsize | __wide | ) | `[inline]`

Changing flags.

Parameters:

  | wide | The new width value.

Returns:
  The previous value of width().

Definition at line 607 of file ios_base.h.

References std::streamsize.

streamsize std::ios_base::width | ( |  | ) | const`[inline]`

Flags access.

Returns:
  The minimum field width to generate on output operations.

"Minimum field width" refers to the number of characters.

Definition at line 599 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::num_put< CharT, OutIter >::do_put(), and std::operator>>().

int std::ios_base::xalloc | ( |  | ) | throw ()`[static]`

Access to unique indices.

Returns:
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

Definition at line 138 of file ios.cc.

## Member Data Documentation

const ios_base::fmtflags std::ios_base::adjustfield `[static]`

| A mask of left|right|internal. Useful for the 2-arg form of `setf`. Definition at line 88 of file ios.cc.

const ios_base::openmode std::ios_base::app `[static]`

| Seek to end before each write. Definition at line 97 of file ios.cc.

const ios_base::openmode std::ios_base::ate `[static]`

| Open and seek to end immediately after opening. Definition at line 98 of file ios.cc.

const ios_base::iostate std::ios_base::badbit `[static]`

| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file). Definition at line 92 of file ios.cc.

const ios_base::fmtflags std::ios_base::basefield `[static]`

| A mask of dec|oct|hex. Useful for the 2-arg form of `setf`. Definition at line 89 of file ios.cc.

const ios_base::seekdir std::ios_base::beg `[static]`

| Request a seek relative to the beginning of the stream. Definition at line 104 of file ios.cc.

const ios_base::openmode std::ios_base::binary `[static]`

| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more. Definition at line 99 of file ios.cc.

const ios_base::fmtflags std::ios_base::boolalpha `[static]`

| Insert/extract `bool` in alphabetic rather than numeric format. Definition at line 73 of file ios.cc.

const ios_base::seekdir std::ios_base::cur `[static]`

| Request a seek relative to the current position within the sequence. Definition at line 105 of file ios.cc.

const ios_base::fmtflags std::ios_base::dec `[static]`

| Converts integer input or generates integer output in decimal base. Definition at line 74 of file ios.cc.

const ios_base::seekdir std::ios_base::end `[static]`

| Request a seek relative to the current end of the sequence. Definition at line 106 of file ios.cc.

const ios_base::iostate std::ios_base::eofbit `[static]`

| Indicates that an input operation reached the end of an input sequence. Definition at line 93 of file ios.cc.

const ios_base::iostate std::ios_base::failbit `[static]`

| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters. Definition at line 94 of file ios.cc.

const ios_base::fmtflags std::ios_base::fixed `[static]`

| Generate floating-point output in fixed-point notation. Definition at line 75 of file ios.cc.

const ios_base::fmtflags std::ios_base::floatfield `[static]`

| A mask of scientific|fixed. Useful for the 2-arg form of `setf`. Definition at line 90 of file ios.cc.

const ios_base::iostate std::ios_base::goodbit `[static]`

| Indicates all is well. Definition at line 95 of file ios.cc.

const ios_base::fmtflags std::ios_base::hex `[static]`

| Converts integer input or generates integer output in hexadecimal base. Definition at line 76 of file ios.cc.

const ios_base::openmode std::ios_base::in `[static]`

| Open for input. Default for `ifstream` and fstream. Definition at line 100 of file ios.cc.

const ios_base::fmtflags std::ios_base::internal `[static]`

| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated. Definition at line 77 of file ios.cc.

const ios_base::fmtflags std::ios_base::left `[static]`

| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.). Definition at line 78 of file ios.cc.

const ios_base::fmtflags std::ios_base::oct `[static]`

| Converts integer input or generates integer output in octal base. Definition at line 79 of file ios.cc.

const ios_base::openmode std::ios_base::out `[static]`

| Open for output. Default for `ofstream` and fstream. Definition at line 101 of file ios.cc.

const ios_base::fmtflags std::ios_base::right `[static]`

| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.). Definition at line 80 of file ios.cc.

const ios_base::fmtflags std::ios_base::scientific `[static]`

| Generates floating-point output in scientific notation. Definition at line 81 of file ios.cc.

const ios_base::fmtflags std::ios_base::showbase `[static]`

| Generates a prefix indicating the numeric base of generated integer output. Definition at line 82 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpoint `[static]`

| Generates a decimal-point character unconditionally in generated floating-point output. Definition at line 83 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpos `[static]`

| Generates a + sign in non-negative generated numeric output. Definition at line 84 of file ios.cc.

const ios_base::fmtflags std::ios_base::skipws `[static]`

| Skips leading white space before certain input operations. Definition at line 85 of file ios.cc.

const ios_base::openmode std::ios_base::trunc `[static]`

| Open for input. Default for `ofstream`. Definition at line 102 of file ios.cc.

const ios_base::fmtflags std::ios_base::unitbuf `[static]`

| Flushes output after each output operation. Definition at line 86 of file ios.cc.

const ios_base::fmtflags std::ios_base::uppercase `[static]`

| Replaces certain lowercase letters with their uppercase equivalents in generated output. Definition at line 87 of file ios.cc.

The documentation for this class was generated from the following files:

- ios_base.h
- ios.cc
- ios_init.cc
- ios_locale.cc